#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
# index.cgi
use HTML::Template;
use Data::Dump qw(dump);
use PureMessage::Manager::Config qw(%config);
use ActiveState::Unix::Crontab qw(cron_format cron_parse cron_install cron_list cron_cmds);
use strict;
#use warnings;
#require './pmx-qdigest-lib.pl';

use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Quarantine::Digest;
use PureMessage::Manager::Lang;
use PureMessage::Manager::Widget;
use PureMessage::List;
use HTML::Entities;


my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Quarantine::Digest',
                                       'stderr_to_stdout' =>1
                                     );

$r->add_help(text => "Help", tab => "quar", page => "mgr_quar_dig" );

my $WIDGET = new PureMessage::Manager::Widget;
$r->{debug} =0;

my %LISTS = map { $_->{id} => $_->{name} } grep { $_->{id} =~ /^digest/ } PureMessage::List->Available();
%LISTS = ( 'digest-users' => 'Digest users' ) unless %LISTS;
our (%text,%in);
my @notifications;
my $show_template;
my $current_form = 'digest_list';

open STDERR, ">&STDOUT";
select STDOUT; $|=1;

#&header($text{'index_title'}, "", undef, 0, 1);
$r->title(text('index_title'));
#print htmlify(dump(%in),1);

my $forms = {
    digest_list => {
        template => 'tmpl/index.html',
    },
    digest_add => {
        template => 'tmpl/digest_edit.html',
    },
    digest_edit => {
        template => 'tmpl/digest_edit.html',
    },
    template_edit => {
        template => 'tmpl/template_edit.html',
    },
};

my $params = {};

ACTION: {
    my $action;
    ($in{'sm_digest_delete'}) and do {
        $r->load_conf(writable=>1);
        for (keys %in) {
            if (/^cb_(.*)$/ and $in{$_} eq 'on') {
                $r->delete_conf_node('digest',$1) or $r->raise_error('node_not_found','digest'.$1);
            }
        }
        $r->save_conf();
        last ACTION;
    };
    ($in{'sm_digest_add'}) and do {
        $current_form = 'digest_add';
        $params->{ta_addr} = $WIDGET->option_list('ta_addr',\%LISTS);
        $params->{SECTION_FOOTER} = $r->ThemeSectionFooter(
                    toolbar=>$r->ToolBar(
                              buttons => [[ { type=>'image',
                                              icon=>'cancel',
                                              alt=>'Cancel',
                                              text=>'Cancel',
                                              name=>'sm_cancel',
                                            },
                                            { type=>'image',
                                              icon=>'save',
                                              alt=>'Save',
                                              text=>'Save',
                                              name=>'sm_digest_save_new',
                                            },
                                         ]],
                                        )
                            )->output();

        $show_template = 1;
        last ACTION;
    };
    ($in{edit}) and do {
        $current_form = 'digest_edit';
        $params->{SECTION_FOOTER} = $r->ThemeSectionFooter(
                    toolbar=>$r->ToolBar( 
                              buttons => [[ { type=>'image',
                                              icon=>'cancel',
                                              alt=>'Cancel',
                                              text=>'Cancel',
                                              name=>'sm_cancel',
                                            },
                                            { type=>'image',
                                              icon=>'save',
                                              alt=>'Save',
                                              text=>'Save',
                                              name=>'sm_digest_save_existing',
                                            },
                                         ]],
                                         )
                            )->output();


        populate_digest_form($in{edit});
        $show_template = 1;
        last ACTION;
    };
    ($action = $in{'sm_digest_save_existing'} || $in{'sm_digest_save_new'}) and do {
        my $digest = $r->strip($in{t_name});
        $digest =~ /^[a-z_][\w-]*$/i or $r->raise_error('error_name_validation',encode_entities($digest,'&<>"\/\''));
        my @reason = grep { length } split(/[\r\s\n\t,;]/,$in{ta_reasons});

        $in{ta_reasons} = \@reason;
        my $old_digest_name = $r->strip($in{old_digest_name});
        my $create = 0;
        $r->load_conf(writable=>1);
        # if this is an edit
        if ($in{sm_digest_save_existing}) {
            # rename the digest, if necessary
            if ($old_digest_name ne $digest) {
                $r->set_conf_groupclass('digest.'.$old_digest_name,$digest);
            }
        }
        # else we are adding a new digest
        else {
            $create = 1;
        }
        if(!$r->error() ) {
                fill_digest_node($digest,$create);
                $r->save_conf();
        }
        if (!$r->error) {
            $current_form = 'digest_list';
            push @notifications, "Digest saved.";
        }
        else {
            $current_form = 'digest_edit';
            $action =~ s/\.x$//;
            $action = encode_entities($action,'&<>"\/\'');
            $params->{SECTION_FOOTER} = $r->ThemeSectionFooter(
		    toolbar=>$r->ToolBar(
                              buttons => [[ { type=>'image',
                                              icon=>'cancel',
                                              alt=>'Cancel',
                                              text=>'Cancel',
                                              name=>'sm_cancel',
                                            },
                                            { type=>'image',
                                              icon=>'save',
                                              alt=>'Save',
                                              text=>'Save',
                                              name=>encode_entities($action,'&<>"\/\''),
                                            },
                                         ]],)
                            )->output();


            $r->reload_text_inputs($params, qw/t_name t_template/);
            $params->{ta_reasons} =  encode_entities(join("\n",@{$in{ta_reasons}}),'&<>"\/\'');
            $params->{ta_addr} = getListOptions($in{ta_addr});
            $params->{old_digest_name} = encode_entities($in{old_digest_name},'&<>"\/\'');
        }
        $show_template = 1;
        last ACTION;
    };
    $r->print( "<table width=600><tr><td>".
            $r->notification_str(text('index_content')).
            "</td></tr></table>");
    last ACTION;
}

populate_digest_list() if $current_form eq 'digest_list';

$params->{SECTION_HEADER} = $WIDGET->section_header(text($current_form.'_header'));

$r->print( "<p>". $r->error_dlg_str() . "</p>") if $r->error;

$r->print("<p>". $r->notification_str($_) . "</p>")  for @notifications;

if ($show_template) {
    my $template = HTML::Template->new(filename=>$forms->{$current_form}->{'template'});
    $template->param($params);
    $r->add_part($template,'body_data');
}

$r->send();

sub populate_digest_list {
    $r->load_conf(is_utf8      => 1);
    $show_template = $r->conf_is_opened();
    my @children = $r->get_conf_children('digest');
    unless ($r->error) {
        for my $child (@children) {
            #print htmlify(dump($child),1);
            next unless $child->groupclass;
            
            my $digest = {
                        NAME => $child->groupclass,
                        TEMPLATE => encode_entities($r->get_conf_value('digest.'.$child->groupclass.'.template'),'&<>"\/\''),
                        REASON => encode_entities(join (", ",$r->get_conf_values('digest.'.$child->groupclass.'.reason')),'&<>"\/\''),
                        ADDR => getListDescription($r->get_conf_value('digest.'.$child->groupclass.'.members')),
            };
            push @{$params->{DIGESTS}}, $digest;
        }
    }
    push @notifications,  text('index_no_digests') unless exists $params->{DIGESTS};
    $params->{SECTION_FOOTER} = $r->ThemeSectionFooter(
                    toolbar=>$r->ToolBar(
                              buttons => [[ { type=>'image',
                                              icon=>'delete',
                                              alt=>'Delete',
                                              text=>'Delete',
                                              name=>'sm_digest_delete',
                                            },
                                            { type=>'image',
                                              icon=>'add',
                                              alt=>'Add',
                                              text=>'Add',
                                              name=>'sm_digest_add',
                                            },
                                         ]],
                                        )
                            )->output();


}

sub create_param_map {
    my $digest = shift; 
    return  ($digest) ? (
                 t_template => 'digest.'.$digest.'.template',
                 ta_reasons => 'digest.'.$digest.'.reason',
                 ta_addr => 'digest.'.$digest.'.members',  
                ) : ();
}

sub fill_digest_node {
    my $digest = shift;
    my $create = shift;
    my %param_map = create_param_map($digest);
    $r->create_conf_node("digest.$digest", 'group') if $create;
    for (keys %param_map) {
        $r->create_conf_node($param_map{$_}, 'option') if $create;
        if (/^ta/) {
            $r->set_conf_value($param_map{$_}, $in{$_} );
        }
        else {
            $r->set_conf_value($param_map{$_}, $in{$_});
        }
    }
}

sub populate_digest_form {
    my $digest = shift;
    my %param_map = create_param_map($digest);
    $r->load_conf();
    $params->{t_name} = encode_entities($digest,'&<>"\/\''),
    $params->{old_digest_name} = encode_entities($digest,'&<>"\/\''),
    $params->{t_template} = $r->get_conf_value($param_map{t_template}),
    $params->{ta_reasons} = join ("\n",$r->get_conf_values($param_map{ta_reasons})),
    $params->{ta_addr} = getListOptions($r->get_conf_values($param_map{ta_addr}));
    #$WIDGET->option_list('ta_addr',\%LISTS, $r->get_conf_values($param_map{ta_addr}));
}

sub getListOptions {
    my $list = shift;
    if ($list and !$LISTS{$list}) {
        # then we need to add it into the list of available lists
        my $data = PureMessage::List->Available($list);
        if ($data) {
                $LISTS{$list} = $data->{name};
        } else {
                # not a valid list, but maybe it will be eventutally so add it
                # to dropdown
                $list = encode_entities($list,'&<>"\/\'');
                $LISTS{$list} = "Invalid List ($list)";
        }
    }
    return $WIDGET->option_list('ta_addr',\%LISTS, $list);
}

sub getListDescription {
        my $list = shift;
        if ($list) {
                my $data = PureMessage::List->Available($list);
                 if ($data) {
                        return "$data->{name}";
                } else {
                        return $list;
                }
               
        } else {
                return '';
        }
}
       

__END__

#$params->{NAME} = get_conf_value();


if ($ENV{'REQUEST_METHOD'} eq 'POST') {
    ACTION: {
        
        ($in{'sm_add.x'}) and do {
            save_conf();
        };
    }
}
else {
    push @notifications, $text{'index_content'} unless @notifications;
}


